package eu.mhsl.craftattack.spawn.appliances.tooling.antiGrief;

import eu.mhsl.craftattack.spawn.appliance.Appliance;
import eu.mhsl.craftattack.spawn.appliances.tooling.antiGrief.player.PlayerGriefListener;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.BlockDisplay;
import org.bukkit.entity.ItemDisplay;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;
import org.bukkit.util.Transformation;
import org.jetbrains.annotations.NotNull;

import javax.annotation.Nullable;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

public class AntiGrief extends Appliance {
    private final Map<Block, UUID> blockRegistry = new HashMap<>();

    public void addTracking(Block block, UUID player) {
        this.blockRegistry.put(block, player);
        block.getLocation().getWorld().spawn(block.getLocation(), ItemDisplay.class, itemDisplay -> {
            itemDisplay.setItemStack(ItemStack.of(Material.FIRE_CHARGE));
            itemDisplay.teleport(block.getLocation().add(0.5, 0.5, 0.5));
        });
    }

    public @Nullable UUID getTracked(Block block) {
        return this.blockRegistry.get(block);
    }

    public void addDestroyed(Block block, UUID player) {
        block.getLocation().getWorld().spawn(block.getLocation().add(0.5, 0.5, 0.5), BlockDisplay.class, blockDisplay -> {
            blockDisplay.setBlock(Material.GOLD_BLOCK.createBlockData());

            Transformation transformation = blockDisplay.getTransformation();
            transformation.getScale().set(0.3);
            blockDisplay.setTransformation(transformation);
        });
    }

    @Override
    protected @NotNull List<Listener> listeners() {
        return List.of(new PlayerGriefListener());
    }
}
