package eu.mhsl.craftattack.spawn.appliances.tooling.antiGrief.player;

import eu.mhsl.craftattack.spawn.appliance.ApplianceListener;
import eu.mhsl.craftattack.spawn.appliances.tooling.antiGrief.AntiGrief;
import net.kyori.adventure.text.Component;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.event.EventHandler;
import org.bukkit.event.block.BlockBurnEvent;
import org.bukkit.event.block.BlockIgniteEvent;
import org.bukkit.event.block.BlockSpreadEvent;

import java.util.UUID;

public class PlayerGriefListener extends ApplianceListener<AntiGrief> {
    @EventHandler
    public void onIgnite(BlockIgniteEvent event) {
        Bukkit.broadcast(Component.text(event.getCause().toString()));
        switch(event.getCause()) {
            case LAVA:
            case SPREAD:
            case EXPLOSION:
                if(event.getIgnitingBlock() == null) return;
                UUID ignitedBy = this.getAppliance().getTracked(event.getIgnitingBlock());
                this.getAppliance().addTracking(event.getBlock(), ignitedBy);
                break;

            case FLINT_AND_STEEL:
            case ENDER_CRYSTAL:
            case ARROW:
            case FIREBALL:
                if(event.getPlayer() == null) return;
                this.getAppliance().addTracking(event.getBlock(), event.getPlayer().getUniqueId());
                break;
        }
    }

    @EventHandler
    public void onSpread(BlockSpreadEvent event) {
        if(!event.getBlock().getType().equals(Material.FIRE)) return;
        UUID ignitedBy = this.getAppliance().getTracked(event.getBlock());
        this.getAppliance().addTracking(event.getBlock(), ignitedBy);
    }

    @EventHandler
    public void onDestroy(BlockBurnEvent event) {
        UUID ignitedBy = this.getAppliance().getTracked(event.getIgnitingBlock());
        if(ignitedBy == null) return;
        this.getAppliance().addDestroyed(event.getBlock(), ignitedBy);
    }
}
